/* ******************************************** */
/* Program   : IDX012.I                         */
/* Purpose   : xref-export procedure            */
/* Parameters: none                             */
/* ******************************************** */
  
  DEF INPUT PARAM        piOutputTo         AS CHAR NO-UNDO.
  DEF INPUT PARAM        piOutputFile       AS CHAR NO-UNDO.
  DEF INPUT PARAM        piSortOrder        AS INT  NO-UNDO.
  DEF INPUT PARAM        piMaxScore         AS DEC  NO-UNDO.
    
  DEF VAR chRange       AS COM-HANDLE NO-UNDO. 
  DEF VAR chColumns     AS COM-HANDLE NO-UNDO. 
  DEF VAR chFirstRow    AS COM-HANDLE NO-UNDO.

  IF piOutputTo = "excel":u
  THEN DO:
     /* Prepare Column headers */  
     ASSIGN iSheetRow   = 1
            iSheetCount = iSheetCount + 1
            cSheetName  = "Sheet":u + STRING(iSheetCount).
     chWorkSheet = chExcelApp:Sheets:Item(iSheetCount) NO-ERROR. 

     chExcelApp:Worksheets(cSheetName):Cells(1, 1)="Score #1":u. 
     chExcelApp:Worksheets(cSheetName):Cells(1, 2)="Score #2":u. 
     chExcelApp:Worksheets(cSheetName):Cells(1, 3)="DatabaseName":u. 
     chExcelApp:Worksheets(cSheetName):Cells(1, 4)="TableName":u.                               
     chExcelApp:Worksheets(cSheetName):Cells(1, 5)="SearchType":u.
     chExcelApp:Worksheets(cSheetName):Cells(1, 6)="AccessedFields":u.
     chExcelApp:Worksheets(cSheetName):Cells(1, 7)="FieldsInIndex":u.
     chExcelApp:Worksheets(cSheetName):Cells(1, 8)="UsedIndexes":u.
     chExcelApp:Worksheets(cSheetName):Cells(1, 9)="FileName":u. 
     chExcelApp:Worksheets(cSheetName):Cells(1,10)="LineNumber":u. 
  END. /* Output to excel */
  ELSE DO:
     OUTPUT STREAM stExport TO VALUE(piOutputFile).
     PUT STREAM stExport UNFORMATTED
         "Score #1|Score #2|DatabaseName|TableName|SearchType|AccessedFields|FieldsInIndex|UsedIndexes|FileName|LineNumber":u SKIP.
  END. /* Output to text */

  CASE (piSortOrder):
     WHEN 1
     THEN FOR EACH ttSearch WHERE ttSearch.IndexScore1 <= piMaxScore NO-LOCK USE-INDEX i2:
        RUN xref-Export-data (INPUT piOutputTo).
     END. /* each ttSearch */
     WHEN 2
     THEN FOR EACH ttSearch WHERE ttSearch.IndexScore2 <= piMaxScore NO-LOCK USE-INDEX i3:
        RUN xref-Export-data (INPUT piOutputTo).
     END. /* each ttSearch */
     OTHERWISE
     FOR EACH ttSearch NO-LOCK USE-INDEX i1:
        RUN xref-Export-data (INPUT piOutputTo).
     END. /* each ttSearch */
  END CASE.

  IF piOutputTo = "excel":u
  THEN DO:
     /* Set First Line (title) to Bold */
     ASSIGN chRange    = chWorkSheet:Range("A1:J1":u) 
            chFirstRow = chRange:FONT. 
     chFirstRow:Bold=TRUE. 
     RELEASE OBJECT chFirstRow  NO-ERROR. 
     RELEASE OBJECT chRange     NO-ERROR. 
     /* Autofit columns */
     ASSIGN chRange   = chWorkSheet:Range("A1:J":u + STRING(iSheetRow)) 
            chColumns = chRange:COLUMNS. 
     chColumns:AutoFit(). 
     RELEASE OBJECT chColumns   NO-ERROR. 
     RELEASE OBJECT chRange     NO-ERROR. 
     /* Give a name to current worksheet */
     chExcelApp:Worksheets(cSheetName):NAME=piOutputFile.
     RELEASE OBJECT chWorksheet NO-ERROR. 
     
     ASSIGN chRange     = ? 
            chFirstRow  = ?
            chColumns   = ?
            chWorksheet = ?. 

  END. /* output to excel */
  ELSE OUTPUT STREAM stExport CLOSE.
