/* ******************************************** */
/* Program   : IDX013.I                         */
/* Purpose   : xref-export-data procedure       */
/* Parameters: none                             */
/* ******************************************** */
  
  DEF INPUT PARAM piOutputTo         AS CHAR  NO-UNDO.

  DEF VAR cFieldsInIndex    AS CHAR NO-UNDO.

  FIND FIRST ttXRef WHERE ttXRef.LineId = ttSearch.Xref-LineId NO-LOCK NO-ERROR.
  cFieldsInIndex = "".
  FOR EACH ttIndex WHERE ttIndex.DatabaseName = ttSearch.DatabaseName
                     AND ttIndex.TableName    = ttSearch.TableName
                     AND LOOKUP(ttIndex.IndexName,ttSearch.UsedIndexes) > 0 NO-LOCK: 
     cFieldsInIndex = cFieldsInIndex + ",":u + ttIndex.FieldName.
  END.
  ASSIGN iSheetRow      = iSheetRow + 1
         cFieldsInIndex = SUBSTRING(cFieldsInIndex,2).
  
  IF piOutputTo = "excel":u
  THEN DO:
     chExcelApp:Worksheets(cSheetName):Cells(iSheetRow, 1)=DEC(STRING(ttSearch.IndexScore1,"ZZ9.9":u)). 
     chExcelApp:Worksheets(cSheetName):Cells(iSheetRow, 2)=DEC(STRING(ttSearch.IndexScore2,"ZZ9.9":u)). 
     chExcelApp:Worksheets(cSheetName):Cells(iSheetRow, 3)=ttSearch.DatabaseName. 
     chExcelApp:Worksheets(cSheetName):Cells(iSheetRow, 4)=ttSearch.TableName.                               
     chExcelApp:Worksheets(cSheetName):Cells(iSheetRow, 5)=ttSearch.SearchType.
     chExcelApp:Worksheets(cSheetName):Cells(iSheetRow, 6)=ttSearch.AccessedFields.
     chExcelApp:Worksheets(cSheetName):Cells(iSheetRow, 7)=cFieldsInIndex.
     chExcelApp:Worksheets(cSheetName):Cells(iSheetRow, 8)=ttSearch.UsedIndexes.
     chExcelApp:Worksheets(cSheetName):Cells(iSheetRow, 9)=ttXRef.xFileName. 
     chExcelApp:Worksheets(cSheetName):Cells(iSheetRow,10)=ttXRef.xLineNumber. 
  END. /* Output to excel */
  ELSE PUT STREAM stExport UNFORMATTED
           ttSearch.IndexScore1      FORMAT ">>9.9"  "|":u
           ttSearch.IndexScore2      FORMAT ">>9.9"  "|":u
           ttSearch.DatabaseName                     "|":u
           ttSearch.TableName                        "|":u
           ttSearch.SearchType                       "|":u
           ttSearch.AccessedFields                   "|":u
           cFieldsInIndex                            "|":u
           ttSearch.UsedIndexes                      "|":u
           ttXRef.xFileName                          "|":u
           ttXRef.xLineNumber        SKIP.
