/* ******************************************** */
/* Program   : IDX002.P                         */
/* Purpose   : Look for Index structure         */
/* Parameters: COMPILE-TIME                     */
/*             {1} Database Name (to look for)  */
/*             {2} Table Name (to look for)     */
/*             {3} Index Name                   */
/*             {4} Database Name (to store)     */
/*             {5} Table Name (to Store)        */
/* ******************************************** */

DEF OUTPUT PARAM poDone AS LOG NO-UNDO INIT FALSE.

&SCOPED-DEFINE DatabaseName       {1}
&SCOPED-DEFINE TableName          {2}
&SCOPED-DEFINE IndexName          {3}
&SCOPED-DEFINE StoredDatabaseName {4}
&SCOPED-DEFINE StoredTableName    {5}

{incl\idx001.i}                             

DEF VAR iLineId  AS INT NO-UNDO.
DEF VAR iRunner  AS INT NO-UNDO.

  
FIND LAST ttIndex NO-LOCK NO-ERROR.
iLineId = IF AVAIL ttIndex THEN (ttIndex.LineId + 1) ELSE 1.  
  
FOR FIRST {&DatabaseName}._File FIELDS() WHERE {&DataBaseName}._File._File-Name = "{&TableName}":U NO-LOCK. END.
IF AVAIL {&DatabaseName}._File
THEN DO iRunner = 1 TO NUM-ENTRIES("{&IndexName}":U):
 
   FOR FIRST {&DatabaseName}._Index FIELDS(_Unique)
                                    WHERE {&DatabaseName}._Index._File-Recid  = RECID({&DatabaseName}._File) 
                                      AND {&DatabaseName}._Index._Index-Name  = ENTRY(iRunner,"{&IndexName}":U) NO-LOCK. END.
   IF AVAIL {&DatabaseName}._Index
   THEN DO:
   
      FOR EACH  {&DatabaseName}._Index-Field FIELDS(_Index-Seq _Ascending)
                                             WHERE {&DatabaseName}._Index-Field._Index-RecId = RECID({&DatabaseName}._Index) NO-LOCK,
          FIRST {&DatabaseName}._Field       FIELDS(_Field-Name)
                                             WHERE RECID({&DatabaseName}._Field) = {&DatabaseName}._Index-Field._Field-RecId NO-LOCK:
      
         CREATE ttIndex.
         ASSIGN ttIndex.LineId       = iLineId
                ttIndex.DatabaseName = "{&StoredDatabaseName}":u
                ttIndex.TableName    = "{&StoredTableName}":u
                ttIndex.IndexName    = ENTRY(iRunner,"{&IndexName}":U)
                ttIndex.FieldName    = {&DatabaseName}._Field._Field-Name
                ttIndex.FieldSeq     = {&DatabaseName}._Index-Field._Index-Seq
                ttIndex.SortOrder    = IF {&DatabaseName}._Index-Field._Ascending
                                       THEN "A":U ELSE "D":U
                ttIndex.IsUnique     = {&DatabaseName}._Index._Unique
                iLineId              = iLineId + 1
                poDone               = TRUE.
      
      END. /* for each _Index-Field */

   END. /* avail _Index */

END. /* avail _File */
