/* ******************************************** */
/* Program   : IDX005.P                         */
/* Purpose   : Count records from a table       */
/* Parameters: COMPILE-TIME                     */
/*             {1} Database Name                */
/*             {2} Table Name                   */
/* ******************************************** */

&SCOPED-DEFINE DatabaseName       {1}
&SCOPED-DEFINE TableName          {2}

{incl\idx002.i}                             

DEF VAR iCount AS INT NO-UNDO.

/* Count Records */
SELECT COUNT(*) INTO iCount FROM {&DatabaseName}.{&TableName}.

FIND FIRST ttRecCount WHERE ttRecCount.DatabaseName = "{&DatabaseName}":u
                        AND ttRecCount.TableName    = "{&TableName}":u EXCLUSIVE-LOCK NO-ERROR.
IF NOT AVAIL ttRecCount
THEN DO:
   CREATE ttRecCount.
   ASSIGN ttRecCount.DatabaseName = "{&DatabaseName}":u
          ttRecCount.TableName    = "{&TableName}":u.
END.

ASSIGN ttRecCount.NumberOfRecords = iCount
       ttRecCount.TimeOfCount     = STRING(TIME,"HH:MM:SS":u).
RELEASE ttRecCount.
